/*
 * $Id: minhack.h,v 1.56 2005/02/02 09:36:01 j_ali Exp $
 * Copyright (C) 2007 J. Ali Harlow
 * Minimal Hack may be freely redistributed.  See license for details.
 */

#ifndef MINHACK_H
#define MINHACK_H

#include <nhproxy/nhproxy.h>

#include "config.h"
#include <curses.h>
#include <menu.h>

#define MINHACK_PICK_NONE	0
#define MINHACK_PICK_ONE	1
#define MINHACK_PICK_ANY	2

struct minhack_mitem {
    struct minhack_mitem *next;
    int identifier;
    int accelerator;
    int groupacc;
    char *str;
    nhproxy_bool_t selected;
    ITEM *item;
};

struct minhack_menu {
    struct minhack_mitem *mitems;
    ITEM **items;
    MENU *menu;
};

struct minhack_window {
    nhproxy_bool_t in_use;
    int type;
    struct minhack_menu *menu;
    WINDOW *win;
};

extern struct nhproxy_clnt_ext_procs minhack_ext_procs;
extern struct minhack_window *windows;
extern int no_windows;
extern int message_win,map_win;

extern int minhack_init_nhwindows(int *, char **, char ***);
extern int minhack_player_selection(int *, int *, int *, int *);
extern char *minhack_askname(void);
extern void minhack_exit_nhwindows(const char *);
extern int minhack_create_nhwindow(int);
extern void minhack_clear_nhwindow(int, int, int, int);
extern void minhack_display_nhwindow(int, NHPROXY_BOOLEAN_P);
extern void minhack_destroy_nhwindow(int);
extern void minhack_curs(int, int, int);
extern void minhack_putstr(int, int, const char *);
extern void minhack_display_file(int fh);
extern void minhack_start_menu(int);
extern void minhack_add_menu(int, int, int, NHPROXY_CHAR_P, NHPROXY_CHAR_P,
  int, const char *, NHPROXY_BOOLEAN_P);
extern void minhack_end_menu(int, const char *);
extern int minhack_select_menu(int, int, struct nhproxy_mi **);
extern int minhack_message_menu(int let, int how, const char *mesg);
extern void minhack_print_glyph(int id, int x, int y, int glyph);
extern void minhack_raw_print(const char *);
extern void minhack_raw_print_bold(const char *);
extern int minhack_nhgetch(void);
extern int minhack_nh_poskey(int *, int *, int *);
extern char minhack_yn_function(const char *, const char *, NHPROXY_CHAR_P,
  int *);
extern char *minhack_getlin(const char *query);
extern int minhack_get_ext_cmd(void);
extern int minhack_outrip(int, char *);
extern void minhack_preference_update(const char *, const char *);
extern void minhack_send_config_file(int);

extern void minhack_free_menu(int window);

#endif	/* MINHACK_H */
